<?php 

namespace Kitt3n\AzureAdForSymfonyBundle\Service;

use League\OAuth2\Client\Token\AccessTokenInterface;
use Microsoft\Graph\Graph;
use Microsoft\Graph\Exception;
use Microsoft\Graph\Model;

class MicrosoftGraphService extends AbstractService
{
    protected $graphMeSelect = '$select=businessPhones,displayName,givenName,jobTitle,mail,mobilePhone,officeLocation,preferredLanguage,surname,userPrincipalName,id,employeeId';

    /**
     * Get User via Graph
     * 
     * @param AccessTokenInterface $accessToken
     * @return Model\User|Exception\GraphException|\Exception|\Throwable
     */
    public function getMicrosoftGraphModelUser(AccessTokenInterface $accessToken)
    {    

        try {

            $graph = $this->getGraph($accessToken);

            $user = $graph->createRequest('GET', '/me?' . $this->graphMeSelect)
                ->setReturnType(Model\User::class)
                ->execute();

            return $user;

        } catch (Exception\GraphException $e) {
            
            return $e;
        
        } catch (\Exception $e) {
        
            return $e;
        
        }

    }

    public function getGraph(AccessTokenInterface $accessToken) 
    {
        $graph = new Graph();
        $graph->setAccessToken($accessToken->getToken());
        return $graph;
    }
}